#include "sudoku.cpp"
#include "mtwin32.h"

/**
 * ̃t@C͌\ɍ쐬̂ł܂ׂƂǋȂƁB
 */
enum SudokuType {								// SudokuReaderǂݍ߂鐔Ƃ̎
	SUDOKU_UNKNOWN= 0,
	SUDOKU_NORMAL,
	SUDOKU_CLASSIC,
	SUDOKU_DIAGONAL,
	SUDOKU_GEOM,
	SUDOKU_COLOR,
	SUDOKU_HIGHLOW,								// s
	SUDOKU_NORMALHIGHLOW,					// MINI Blocks
	SUDOKU_ONEDIFF,								// Ⴂ
	SUDOKU_ZERONINE,							// 0to9
	SUDOKU_BIGHEAD,								// ł
	SUDOKU_OVERLAPPED,						// dˍ킹
};

class SudokuReader {
public:
	SudokuReader();
	YesNo read_file( cstring path);
	Sudoku* detach();

private:
	void eliminate();
	YesNo setdata( int row, cstring line); // ǂݍ񂾍sݒ肷
	YesNo read_option( cstring s); // eivɉwǂݍ
	YesNo read_option_geom( cstring s);
	YesNo read_option_color( cstring s);
	YesNo read_option_highlow( cstring s);
	YesNo read_option_onediff( cstring s);
	YesNo read_option_bighead( cstring s);
	YesNo read_overlapped( mt_text_file& tf);	// t@C̓rĂяoB
	YesNo init_end_geom();
	int get_pos( cstring s, int pos[MAXVAL]);

private:
	mt_string     m_path;					// ǂݍރt@C
	SudokuType    m_type;					// ǂݍ񂾐Ƃ̎
	Sudoku*       m_sudoku;				// ǂݍ񂾐(NormalSudoku,ClassicSudoku,DiagonalSudoku,...)ւ̃|C^
	int           m_1digit;				// 2ɂȂ,ႦMINIBOX5x525܂ł̐̓͂ƂC122ɂȂ\B25̎3ݒ肷B
	mt_string     m_row_wall;			// #rowwall,333,522,...
	mt_string     m_col_wall;			// #colwall,234,
	int           m_line;					// #highlow̍s
};

SudokuReader::SudokuReader()
{
	m_type        = SUDOKU_UNKNOWN;
	m_sudoku      = NULL;
	m_line        = 0;
}

/**
 * ǂݍ񂾍sw̍sɐݒ肷B
 */
YesNo SudokuReader::setdata( int row, cstring line)
{
	cstring       s = line;
	int col = 0;
	YesNo         yn_zeronine = NO;	// 0to9/o玟͓Box
	while(*s) {
		if( *s == '.') {
			if( yn_zeronine) { ((ZeroNineSudoku*)m_sudoku)->init_another_boxval( row, col-1, BoxValNone); yn_zeronine = NO;}
			else m_sudoku->init_boxval( row, col++, BoxValNone);
		}
		else if( *s == '0') {
			//----------------------------------------------------------------
			// 01̃vtBbNXƌȂB
			//----------------------------------------------------------------
			if( yn_zeronine) { ((ZeroNineSudoku*)m_sudoku)->init_another_boxval( row, col-1, *(s+1) - '0'); yn_zeronine = NO;}
			else m_sudoku->init_boxval( row, col++, *(s+1) - '0');
			s++;
		}
		else if( (*s-'0') >= m_1digit) {
			if( yn_zeronine) { ((ZeroNineSudoku*)m_sudoku)->init_another_boxval( row, col-1, *s - '0'); yn_zeronine = NO;}
			else m_sudoku->init_boxval( row, col++, *s - '0');
		}
		else if( *s >= '1' && *s <= '9') {
			//----------------------------------------------------------------
			// QɂȂB
			//----------------------------------------------------------------
			if( *(s+1)) {
				if( yn_zeronine) { ((ZeroNineSudoku*)m_sudoku)->init_another_boxval( row, col-1, (*s - '0')*10 + (*(s+1) - '0')); yn_zeronine = NO;}
				else m_sudoku->init_boxval( row, col++, (*s - '0')*10 + (*(s+1) - '0'));
				s++;
			}
			else {
				// s
				pe( "2łȂ΂ȂȂ̂1oȂB\n");
			}
		}
		else if( *s == '/' && m_type == SUDOKU_ZERONINE) { // 0to9iv,2lBox
			yn_zeronine   = YES;
		}
		else {
			pe( "SudokuReader::read_file(%s) Unknown Char(%c)\n", (cstring)m_path, *s);
			return    NO;
		}
		s++;
	}
	if( col != m_sudoku->get_cols()) {
		pe( "SudokuReader::read_file(%s) [%d]̗(%d)wƈv(%d)Ȃ\n", (cstring)m_path, row, col, m_sudoku->get_cols());
		return NO;
	}
	return YES;
}

/**
 * ̂Ƃ
 * 1.ό`iv̕ǂǂݍށB
 * 2.J[iv̐FBlockǂݍށB
 */
YesNo SudokuReader::read_option( cstring s)
{
	if( *s != '#') return    NO;
	switch( m_type) {
	case SUDOKU_GEOM:
		return    read_option_geom( s);
		break;
	case SUDOKU_COLOR:
		return    read_option_color( s);
		break;
	case SUDOKU_HIGHLOW:
	case SUDOKU_NORMALHIGHLOW:
		return    read_option_highlow( s);
		break;
	case SUDOKU_ONEDIFF:
		return    read_option_onediff( s);
		break;
	case SUDOKU_BIGHEAD:
		return    read_option_bighead( s);
		break;
	default:
		// 悤ȁB
		return    YES;
	}
}

/**
 */
YesNo SudokuReader::read_option_geom( cstring s)
{
	cstring       key_row_wall = "#rowwall,";
	cstring       key_col_wall = "#colwall,";
	if( mt_strleftequal( s, key_row_wall, strlen(key_row_wall))) {
		m_row_wall  = s+strlen(key_row_wall);
	}
	else if( mt_strleftequal( s, key_col_wall, strlen( key_col_wall))) {
		m_col_wall  = s+strlen(key_col_wall);
	}
	return    YES;
}

/**
 * J[iv̐FBlockǂݍށB
 * FBlockBoẍʒuSė񋓂B
 * #color,row,col,row,col,...
 * F2F΁C#color2sɂȂB3F3sɂȂB
 */
YesNo SudokuReader::read_option_color( cstring s)
{
	// ̃`FbNsāCl̃`FbNColorSudokûɔCB
	BoxPos        pos[MAXVAL];
	int           n = 0;
	cstring       key = "#color,";
	if( mt_strleftequal( s, key, strlen(key))) {
		s           += strlen(key);
		ColorSudoku* sudoku = (ColorSudoku*)m_sudoku;
		mt_token    token( ",", MAXVAL);
		int         row, col;
		int         maxval = m_sudoku->get_maxval();
		if( token.split( s) == maxval*2) {
			for( int i=0; i< maxval; i++) {
				row     = mt_atoi(token[2*i]);
				col     = mt_atoi(token[2*i+1]);
				pos[i]  = sudoku->rowcol2pos( row, col);
			}
			if( sudoku->set_color_block_pos( pos)) {
				return    YES;
			}
			pe( "ݒɃ~XL\n");
			return    NO;
		}
		else {
			pe( "Ҍ(%d)Ǝ(%d)vȂ\n", maxval*2, token.get_num_token());
			return    NO;
		}
	}
	pe( "łȂL[[h");
	return    NO;
}

/**
 * siv̕sǂݍށB
 * s͖ĂǂB
 * . sB
 * >,< EBoxƂ̊Ԃ̕s
 * v,^ BoxƂ̊Ԃ̕s
 */
YesNo SudokuReader::read_option_highlow( cstring s)
{
	// EBoxƂ̊Ԃ̕s m_maxval-1 oB
	// BoxƂ̊Ԃ̕s m_maxval oB
	cstring       key = "#highlow,";
	if( mt_strleftequal( s, key, strlen(key))) {
		s           += strlen(key);
		HighLowSudoku* sudoku = (HighLowSudoku*)m_sudoku;
		HighLow     hl;
		if( m_line&1) {							// sԂ̕s
			int       col = 0;
			while( *s) {
				if( *s == 'v') {
					hl    = HL_GT;
				}
				else if( *s == '^') {
					hl    = HL_LT;
				}
				else if( *s == '.') {
					hl    = HL_UNKNOWN;
				}
				else {
					pe( "Unknown char(%c)\n", *s);
					return    NO;
				}
				if( sudoku->set_row_high_low( m_line/2/*s*/, col, hl)) {
					col++;
				}
				else {
					pe( "HighLowoȂ(ƂR)row:%d,col:%d\n", m_line/2, col);
					return    NO;
				}
				s++;
			}
		}
		else {											// Ԃ̕s
			int       col = 0;
			while( *s) {
				if( *s == '>') {
					hl    = HL_GT;
				}
				else if( *s == '<') {
					hl    = HL_LT;
				}
				else if( *s == '.') {
					hl    = HL_UNKNOWN;
				}
				else {
					pe( "Unknown char(%c)\n", *s);
					return    NO;
				}
				if( sudoku->set_col_high_low( m_line/2/*s*/, col, hl)) {
					col++;
				}
				else {
					pe( "HighLowoȂ(ƂR\n");
					return    NO;
				}
				s++;
			}
		}
		m_line++;
		return    YES;
	}
	else {
		pe( "łȂL[[h(%s)\n", s);
		return    NO;
	}
}

/**
 * Ⴂiv̓ǂݍ݁B
 * 11ႢB
 * 22ႢB
 * x͔{ႢB
 * -1Ⴂł{ႢłB
 */
YesNo SudokuReader::read_option_onediff( cstring s)
{
	// EBoxƂ̊Ԃ̋L͂ m_maxval-1 oB
	// BoxƂ̊Ԃ̋L m_maxval oB
	cstring       key = "#onediff,";
	if( mt_strleftequal( s, key, strlen(key))) {
		s           += strlen(key);
		OneDiffSudoku* sudoku = (OneDiffSudoku*)m_sudoku;
		OneDiff     od;
		if( m_line&1) {							// sԂ̍
			int       col = 0;
			while( *s) {
				if( *s == '.') {
					od    = OD_UNKNOWN;
				}
				else if( *s == '1') {
					od    = OD_DIFF1;
				}
				else if( *s == '2') {
					od    = OD_DIFF2;
				}
				else if( *s == 'x') {
					od    = OD_DOUBLE;
				}
				else if( *s == '-') {
					od    = OD_NOTDIFF1DBL;
				}
				else {
					pe( "Unknown char(%c)\n", *s);
					return    NO;
				}
				if( sudoku->set_row_diff( m_line/2/*s*/, col, od)) {
					col++;
				}
				else {
					pe( "OneDiffoȂ(ƂR)row:%d,col:%d\n", m_line/2, col);
					return    NO;
				}
				s++;
			}
		}
		else {											// Ԃ̍
			int       col = 0;
			while( *s) {
				if( *s == '.') {
					od    = OD_UNKNOWN;
				}
				else if( *s == '1') {
					od    = OD_DIFF1;
				}
				else if( *s == '2') {
					od    = OD_DIFF2;
				}
				else if( *s == 'x') {
					od    = OD_DOUBLE;
				}
				else if( *s == '-') {
					od    = OD_NOTDIFF1DBL;
				}
				else {
					pe( "Unknown char(%c)\n", *s);
					return    NO;
				}
				if( sudoku->set_col_diff( m_line/2/*s*/, col, od)) {
					col++;
				}
				else {
					pe( "OneDiffoȂ(ƂR\n");
					return    NO;
				}
				s++;
			}
		}
		m_line++;
		return    YES;
	}
	else {
		pe( "łȂL[[h(%s)\n", s);
		return    NO;
	}
}

/**
 */
YesNo SudokuReader::read_option_bighead( cstring s)
{
	cstring       key = "#bighead,";
	if( mt_strleftequal( s, key, strlen(key))) {
		s           += strlen(key);
		BigHeadSudoku* sudoku = (BigHeadSudoku*)m_sudoku;
		BoxVal      boxval = mt_atoi( s);
		sudoku->set_local_maxval( boxval);
	}
	return    YES;
}

/**
 * dˍ킹ǂݍށB
 * t@C̓rĂяoB
 */
YesNo SudokuReader::read_overlapped( mt_text_file& tf)
{
	OverlappedSudoku* overlapped_sudoku   = (OverlappedSudoku*)m_sudoku;
	cstring       s;
	cstring       key = "#overlapped,";
	while( (s=tf.get_line()) != NULL) {
		if( *s == NIL) continue;
		if( *s == ';') continue;
		if( mt_strleftequal( s, key, strlen(key))) {
			s         += strlen(key);
			mt_token    token( ",", 3+1);	// rows,cols,filename
			if( token.split( s) == 3) {
				int       row = mt_atoi( token[0]);
				int       col = mt_atoi( token[1]);
				cstring   fn  = token[2];
				SudokuReader  sr;
				if( sr.read_file( fn) == YES) {
					int idx = overlapped_sudoku->add( sr.detach());
					overlapped_sudoku->move( idx, row, col);
				}
				else {
					return    NO;						// ǂݍݎs
				}
			}
		}
		else {
			pe( "łȂL[[h(%s)\n", s);
			return    NO;
		}
	}
	return    YES;
}

/**
 * Ƃ̖t@CǂݍށB
 */
YesNo SudokuReader::read_file( cstring path)
{
	m_path        = path;
	if( !mt_is_exist_file( path)) {
		pe( "t@C(%s)܂B\n", path);
		return    NO;
	}
	mt_text_file  tf;
	if( !tf.open( path)) {
		pe( "t@C(%s)I[vł܂B\n", path);
		return    NO;
	}
	cstring       s;
	int           iLine = 0;
	s             = tf.get_line();									// @*,* or *x*
	if( s == NULL || *s == NIL) {
		pe( "SudokuReader::read_file(%s) t@CɃf[^܂B\n", path);
		return    NO;
	}
	// ŏ̍s ~jubN rows x cols ĂB
	if( *s == '@') s++;
	mt_token      size( "x,", 3);	// ۂ3łȂ2G[`FbN̂߂3ɂĂ
	size.split( s);
	if( size.get_num_token() != 2 && size.get_num_token() != 3) {
		pe( "SudokuReader::read_file(%s) Ֆʂ̑傫w肳Ă܂B(%s)\n", path, s);
		return    NO;
	}
	m_type        = SUDOKU_NORMAL;
	if( size.get_num_token() == 3) { // 3̎́CƂ̎ނĂ
		cstring     type = size[2];
		if( mt_strequal( type, "normal")) {
			m_type    = SUDOKU_NORMAL;
		}
		else if( mt_strequal( type, "classic")) {
			m_type    = SUDOKU_CLASSIC;
		}
		else if( mt_strequal( type, "diagonal")) {
			m_type    = SUDOKU_DIAGONAL;
		}
		else if( mt_strequal( type, "geom")) {
			m_type    = SUDOKU_GEOM;
		}
		else if( mt_strequal( type, "color")) {
			m_type    = SUDOKU_COLOR;
		}
		else if( mt_strequal( type, "highlow")) {
			m_type    = SUDOKU_HIGHLOW;
			m_line    = 0;
		}
		else if( mt_strequal( type, "normalhighlow")) {
			m_type    = SUDOKU_NORMALHIGHLOW;
			m_line    = 0;
		}
		else if( mt_strequal( type, "onediff")) {
			m_type    = SUDOKU_ONEDIFF;
			m_line    = 0;
		}
		else if( mt_strequal( type, "zeronine")) {
			m_type    = SUDOKU_ZERONINE;
			m_line    = 0;
		}
		else if( mt_strequal( type, "bighead")) {
			m_type    = SUDOKU_BIGHEAD;
			m_line    = 0;
		}
		else if( mt_strequal( type, "overlapped")) {
			m_type    = SUDOKU_OVERLAPPED;
			m_line    = 0;
		}
		else {											// ȊȌ݂͓ǂݍ߂Ȃ
			pe( "SudokuReader::read_file(%s) ǂݍ߂Ȃ(%s)̐ƂłB\n", path, type);
			return    NO;
		}
	}
	int           mini_block_rows = mt_atoi(size[0]);
	int           mini_block_cols = mt_atoi(size[1]);
	int           maxval = mini_block_rows * mini_block_cols;
	int rows        = mini_block_rows * mini_block_cols;
	int cols        = mini_block_rows * mini_block_cols;
	ps( "Ֆ s:%d, :%d, MINI %dx%d\n", rows, cols, mini_block_rows, mini_block_cols);
	switch( m_type) {
	case SUDOKU_NORMAL:
		m_sudoku    = new NormalSudoku( rows, cols, mini_block_rows, mini_block_cols, maxval);
		break;
	case SUDOKU_CLASSIC:
		m_sudoku    = new ClassicSudoku( rows, cols, maxval);
		break;
	case SUDOKU_DIAGONAL:
		m_sudoku    = new DiagonalSudoku( rows, cols, mini_block_rows, mini_block_cols, maxval);
		break;
	case SUDOKU_GEOM:
		rows        = mini_block_rows;
		cols        = mini_block_cols;
		if( rows != cols) return    NO;	// m[}łȂsƂ͐`Ɍ肳
		maxval      = rows;					
		m_sudoku    = new GeomSudoku( rows, cols, maxval);
		break;
	case SUDOKU_COLOR:
		m_sudoku    = new ColorSudoku( rows, cols, mini_block_rows, mini_block_cols, maxval);
		break;
	case SUDOKU_HIGHLOW:
		rows        = mini_block_rows;
		cols        = mini_block_cols;
		if( rows != cols) return    NO;	// m[}łȂsƂ͐`Ɍ肳
		maxval      = rows;					
		m_sudoku    = new HighLowSudoku( rows, cols, maxval);
		break;
	case SUDOKU_ONEDIFF:
		m_sudoku    = new OneDiffSudoku( rows, cols, mini_block_rows, mini_block_cols, maxval);
		break;
	case SUDOKU_ZERONINE:
		m_sudoku    = new ZeroNineSudoku( rows, cols, mini_block_rows, mini_block_cols, ++maxval/*͂*/);
		break;
	case SUDOKU_BIGHEAD:
		rows        = mini_block_rows;
		cols        = mini_block_cols;
		if( rows != cols) return    NO;	// ł͑`
		maxval      = rows;					
		m_sudoku    = new BigHeadSudoku( rows, cols, maxval);
		break;
	case SUDOKU_NORMALHIGHLOW:
		m_sudoku    = new HighLowSudoku( rows, cols, mini_block_rows, mini_block_cols, maxval);
		break;
	case SUDOKU_OVERLAPPED:
		m_sudoku    = new OverlappedSudoku();	// dˍ킹ɂ͑傫̎w肪KvȂ
		return    read_overlapped( tf);	// ՖʂĂ킯ł͂Ȃ̂ŁCǂݍ݂͕ʊ֐𗘗pB
		break;
	case SUDOKU_UNKNOWN:
	default:
		mt_assert(false);						// program error
	}
	m_1digit      = ( maxval / 10 ) + 1; // 2łȂ1œ͉\Ȑ
	int           row = 0;
	m_sudoku->init_start();						// ۂ͒g͋
	while( (s=tf.get_line()) != NULL) {
		if( *s == ';') continue;		// s̃Z~R̓RgȂ
		if( *s == '#') {
			if( read_option( s) == NO) return    NO;
			continue;
		}
		if( setdata( row, s) == NO) {
			return    NO;
		}
		row++;
	}
	if( row != rows) {
		pe( "SudokuReader::read_file(%s) ǂݍ񂾍s(%d)wƈvȂ(%d)\n",path,row,rows);
		return NO;
	}
	if( m_type == SUDOKU_GEOM) {
		return    init_end_geom();
	}
	else {
		return    m_sudoku->init_end();
	}
}

/**
 * ό`ƂBlock`B
 * ό`Ƃ̏ꍇCBlock𒼐ڒ`Ă킯łȂǂ`Ă̂ŁC
 * ǂǂݍ񂾌Block𒲂ׂ邱ƂɂȂB
 * sĂ̂B
 */
YesNo SudokuReader::init_end_geom()
{
	// 333,521,... ̂悤ɓĂB
	// 10ȏ̏ꍇ A0,A1,...
	// 20ȏ̏ꍇ B0,B1,...
	// 30ȏ̏ꍇ C0,C1,...
	mt_token      token( ",", m_sudoku->get_maxval());
	int           pos[MAXVAL+10];
	int           num_wall;
	GeomSudoku* sudoku = (GeomSudoku*)m_sudoku;
	int           row = 0;
	int           col = 0;
	int           n = token.split( m_row_wall);
	int           i;
	for( i=0; i< n; i++) {
		num_wall    = get_pos( token[i], pos);
		if( sudoku->set_row_wall( row, pos, num_wall) == NO) return    NO;
		row++;
	}
	n             = token.split( m_col_wall);
	for( i=0; i< n; i++) {
		num_wall    = get_pos( token[i], pos);
		if( sudoku->set_col_wall( col, pos, num_wall) == NO) return    NO;
		col++;
	}
	ps( "init_end(sǐ:%d,ǐ:%d)\n", row, col);
	if( m_sudoku->get_rows() != row || m_sudoku->get_cols() != col) {
		pe( "sǂ̐v܂BǓBoxv(%d)!=s(%d)\n", row, m_sudoku->get_rows());
		pe( "ǂ̐v܂BǓBoxv(%d)!=(%d)\n", col, m_sudoku->get_cols());
	}
	return    sudoku->init_end();
}

/**
 * 񂩂ǂ܂ł̒擾B
 * ό`Ƃ͂ꍇCBlockBoxw肷̂łȂ
 * ՖʑŜ̕ǂ̈ʒuw肷B
 * esCe񖈂ɏ̕ǂC̕ǂBoxĂB
 * Ⴆ333̏ꍇCpos[0]=0, pos[1]=3, pos[2]=6, pos[3]=9 ԂB
 */
int SudokuReader::get_pos( cstring s, int pos[MAXVAL])
{
	int           n = 0;
	pos[0]        = 0;
	while( *s) {
		if( *s >= 'A' && *s <= 'C') {
			pos[n]    = (*s - 'A' + 1)*10;
		}
		else if( *s >= '0' && *s <= '9') {
			pos[n]    += *s - '0';
			if( ++n >= MAXVAL) return    0;
			pos[n]    = 0;
		}
		s++;
	}
	return    n;
}

/**
 * ǂݍ񂾖ԂB
 * ĂяoƂ̃NX2ӏŃ|C^̂͗ǂȂ̂ŁC̓|C^NULLɐݒ肷B
 * Ăяo delete ĂĂƁB
 */
Sudoku* SudokuReader::detach()
{
	Sudoku*       sudoku = m_sudoku;
	m_sudoku    = NULL;
	return    sudoku;
}

int main( int argc, cstring argv[])
{
	mt_option opt( "cdf", "t", argc, argv);
	int           timeout = opt.get_long( 't', 0);
	YesNo         yn_classic_sudoku = opt.is_exist('c');
	YesNo         yn_diagonal_sudoku = opt.is_exist('d');
	YesNo         yn_force = opt.is_exist('f');	// Iɉ
	cstring       path = opt.get_argument(0);
	Sudoku*       sudoku = NULL;
	SudokuReader  sr;
	if( sr.read_file( path)) {
		sudoku    = sr.detach();
		if( timeout != 0) sudoku->set_timeout( timeout);
	}
	if( sudoku != NULL) {
		YesNo       yn_solve;
		sudoku->print();
		sudoku->dump_koho();
		yn_solve  = sudoku->solve( yn_force);
		sudoku->print();
		sudoku->dump_koho();
		if( yn_solve) pe( "%s OK%s\n", path, sudoku->is_multi_answer()?" MULTI":"");
		else          pe( "%s NG%s\n", path, sudoku->is_timeout()?" TIMEOUT":(sudoku->is_data_error()?" DATAERROR":""));
	}
	return    0;
}
